 ;-----------------------------------------------------------------------------------
 ;                                                                                  ;
 ;                                      APIS                                        ;
 ;                                                                                  ;
 ;                                                                                  ;
 ;                                                                                  ;
 ;-----------------------------------------------------------------------------------

.586
Option CaseMap:none
Include C:\masm32\include\windows.inc
Include C:\masm32\include\kernel32.inc

.Data
API_ADDRESS_OFFSET Equ 10       ;this is the offset between the beginning of a Proc and the place to put the delta
.Code

;here we will put every API in this form for some reasons:
;1.use the Api easily by invoke and see the parameters of each api
;2.reserve ecx and edx as some apis change their values . we avoid them from modification
;3.avoid every time get the delta to call to the api (call [ebx+_XXXXX])
;4.a bit of anti-apiHookers and anti-fast analysis (setting a breakpoint on the beginning of the api)

GetCurrentDirectoryAPI Proc Uses Ecx Edx nBufferLength:DWord,lpBuffer:DWord
Call _@1
    _GetCurrentDirectoryA DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push lpBuffer
    Push nBufferLength
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
GetCurrentDirectoryAPI EndP

SetCurrentDirectoryAPI Proc Uses Ecx Edx lpPathName:DWord
Call _@1
    _SetCurrentDirectoryA DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push lpPathName
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
 SetCurrentDirectoryAPI EndP

FindFirstFileAPI Proc Uses Ecx Edx hFindFile:DWord,lpFindFileData:DWord
Call _@1
    _FindFirstFileA DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push lpFindFileData
    Push hFindFile
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
FindFirstFileAPI EndP

FindNextFileAPI Proc Uses Ecx Edx lpFindFileData:DWord,hFindFile:DWord
Call _@1
    _FindNextFileA DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push hFindFile
    Push lpFindFileData
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
FindNextFileAPI EndP
FindCloseAPI Proc Uses Ecx Edx hFindFile:DWord
Call _@1
    _FindClose DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Sub Edx,1
    Push hFindFile
    Call _@2
    Jmp _@3
_@2:
    Push 24H
    Jmp Edx
_@3:
    Ret
FindCloseAPI EndP

CreateFileMappingAPI Proc Uses Ecx Edx hFile:DWord, lpFileMappingAttributes:DWord,flProtect:DWord,dwMaximumSizeHigh:DWord,dwMaximumSizeLow:DWord,lpName:DWord
Call _@1
    _CreateFileMapping DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push lpName
    Push dwMaximumSizeLow
    Push dwMaximumSizeHigh
    Push flProtect
    Push  lpFileMappingAttributes
    Push hFile
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
CreateFileMappingAPI EndP

MapViewOfFileAPI Proc Uses Ecx Edx hFileMappingObject:DWord,dwDesiredAccess:DWord,dwFileOffsetHigh:DWord,dwFileOffsetLow:DWord,dwNumberOfBytesToMap:DWord
Call _@1
    _MapViewOfFile DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push dwNumberOfBytesToMap
    Push dwFileOffsetLow
    Push dwFileOffsetHigh
    Push dwDesiredAccess
    Push hFileMappingObject
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
 MapViewOfFileAPI EndP

CloseHandleAPI Proc Uses Ecx Edx Handle:DWord
Call _@1
    _CloseHandle DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push Handle
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
CloseHandleAPI EndP
UnmapViewOfFileAPI Proc Uses Ecx Edx lpBaseAddress:DWord
Call _@1
    _UnmapViewOfFile DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push lpBaseAddress
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
UnmapViewOfFileAPI EndP

CreateFileAPI Proc Uses Ecx Edx lpFileName:DWord,dwDesiredAccess:DWord,dwShareMode:DWord,lpSecurityAttributes:DWord,dwCreationDistribution:DWord,dwFlagsAndAttributes:DWord, hTemplateFile:DWord
Call _@1
    _CreateFileA DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push hTemplateFile
    Push dwFlagsAndAttributes
    Push dwCreationDistribution
    Push lpSecurityAttributes
    Push dwShareMode
    Push dwDesiredAccess
    Push lpFileName
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
CreateFileAPI EndP
ReadFileAPI Proc Uses Ecx Edx hFile:DWord,lpBuffer:DWord,nNumberOfBytesToRead:DWord,lpNumberOfBytesRead:DWord,lpOverlapped:DWord
Call _@1
    _ReadFile DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Sub Edx,1
    Push lpOverlapped
    Push lpNumberOfBytesRead
    Push nNumberOfBytesToRead
    Push lpBuffer
    Push hFile
    Call _@2
    Jmp _@3
_@2:
    Push 20H
    Jmp Edx
_@3:
    Ret
 ReadFileAPI EndP
WriteFileAPI Proc Uses Ecx Edx hFile:DWord,lpBuffer:DWord,nNumberOfBytesToWrite:DWord,lpNumberOfBytesWritten:DWord,lpOverlapped:DWord
Call _@1
    _WriteFile DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Sub Edx,1
    Push lpOverlapped
    Push lpNumberOfBytesWritten
    Push nNumberOfBytesToWrite
    Push lpBuffer
    Push hFile
    Call _@2
    Jmp _@3
_@2:
    Push 18H
    Jmp Edx
_@3:
    Ret
 WriteFileAPI EndP

SetFileAttributesAPI Proc Uses Ecx Edx lpFileName:DWord,dwFileAttributes:DWord
Call _@1
    _SetFileAttributesA DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push dwFileAttributes
    Push lpFileName
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
SetFileAttributesAPI EndP

LoadLibraryAPI Proc Uses Ecx Edx szDllName:DWord
Call _@1
    _LoadLibraryA DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push szDllName
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
LoadLibraryAPI EndP
GetTickCountAPI Proc Uses Ecx Edx
Call _@1
    _GetTickCount DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Sub Edx,3
    Call _@2
    Jmp _@3
_@2:
    Jmp Edx
_@3:
    Ret
GetTickCountAPI EndP

VirtualAllocAPI Proc Uses Ecx Edx lpAddress:DWord,dwSize:DWord,flAllocationType:DWord,flProtect:DWord
Call _@1
    _VirtualAlloc DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push flProtect
    Push flAllocationType
    Push dwSize
    Push lpAddress
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
VirtualAllocAPI EndP
MessageBoxAPI Proc Uses Ecx Edx hWnd:DWord,lpText:DWord,lpCaption:DWord,uType:DWord
Call _@1
    _MessageBoxA DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push uType
    Push lpCaption
    Push lpText
    Push hWnd
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
MessageBoxAPI EndP
VirtualProtectAPI   Proc Uses Ecx Edx lpAddress:DWord,dwSize:DWord, flNewProtect:DWord, lpflOldProtect:DWord
Call _@1
    _VirtualProtect DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push lpflOldProtect
    Push flNewProtect
    Push dwSize
    Push lpAddress
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
VirtualProtectAPI EndP
SetWindowLongAPI    Proc Uses Ecx Edx hWnd:DWord,nIndex:DWord,dwNewLong:DWord
Call _@1
    _SetWindowLong DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push dwNewLong
    Push nIndex
    Push hWnd
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
SetWindowLongAPI EndP
CallWindowProcAPI   Proc Uses Ecx Edx lpPrevWndFunc:DWord,hWnd:DWord,Msg:DWord,wParam:DWord,lParam:DWord
Call _@1
    _CallWindowProc DD ?
_@1:
    Pop Edx
    Mov Edx,DWord Ptr [Edx]
    Push lParam
    Push wParam
    Push Msg
    Push hWnd
    Push lpPrevWndFunc
    Call _@2
    Jmp _@3
_@2:
    Mov Edi,Edi
    Push Ebp
    Jmp Edx
_@3:
    Ret
CallWindowProcAPI EndP
